; la TI-76.fr est une calculatrice de type TI-83
; elle utilise la version 1.00fr5 de la ROM

; or, sur cette ROM la combinaison de touches
; [MODE] [ALPHA] [S] pour afficher la version et lancer l'auto-test
; ne marche plus
;
; en attendant de dcouvrir la nouvelle combinaison de touches
; ce programme assembleur permet d'accder  l'cran d'auto-test
;
; aprs analyse de la ROM, le message "Enter l'auto-tst 1.00fr5"
; est situ  l'adresse $02D08 entre d'autres messages
;
; il y a une rfrence  ce message  l'adresse $0C00A
; la routine en question commence  l'adresse $0C000

; REMARQUE: L'ADRESSE $0C000 EST SPECIFIQUE A LA TI-76.FR.
; L'UTILISATION DE CE PROGRAMME NON MODIFIE SUR TOUTE AUTRE TI-83
; (TI-82 STATS, TI-82 STATS.FR) PROVOQUERA TRES CERTAINEMENT UN
; PLANTAGE AVEC PERTE DE MEMOIRE, CAR CE NE SERA PLUS LA BONNE ADRESSE.
;
; LE BUT DE CE PROGRAMME ASSEMBLEUR SIMPLE EST DONC
; DE LANCER LA ROUTINE A L'ADRESSE $0C000
;
; RAPPEL: A L'ECRAN D'AUTO-TEST, UN APPUI SUR LA TOUCHE ENTREE
; LANCERA L'AUTO-TEST QUI EFFACERA LA MEMOIRE !!!
; UN APPUI SUR TOUTE AUTRE TOUCHE QUITTE CET ECRAN SANS DOMMAGE.
;
; le processeur Z80 ne peut accder simultanment
; qu' 64Ko de mmoire RAM ou ROM
;
; or la ROM de la TI-83 fait dj 256Ko, et la RAM 32Ko
;
; pour remdier  ce problme, la ROM est dcoupe en 16 pages
; numrotes de 0  15
;
;  tout moment, le Z80 a accs:
; -  la ROM page 0 (0000-3FFF) mappe aux adresses (0000-3FFF)
; -  une ROM page de 0  15    mappe aux adresses (4000-7FFF)
; -  toute la RAM              mappe aux adresses (8000-FFFF)
;
; la ROM page  0 correspond  la zone 00000-03FFF de la ROM
; la ROM page  1 correspond  la zone 04000-07FFF de la ROM
; la ROM page  2 correspond  la zone 08000-0BFFF de la ROM
; la ROM page  3 correspond  la zone 0C000-0FFFF de la ROM
; la ROM page  4 correspond  la zone 10000-13FFF de la ROM
; la ROM page  5 correspond  la zone 14000-17FFF de la ROM
; la ROM page  6 correspond  la zone 18000-1BFFF de la ROM
; la ROM page  7 correspond  la zone 1C000-1FFFF de la ROM
; la ROM page  8 correspond  la zone 20000-23FFF de la ROM
; la ROM page  9 correspond  la zone 24000-27FFF de la ROM
; la ROM page 10 correspond  la zone 28000-2BFFF de la ROM
; la ROM page 11 correspond  la zone 2C000-2FFFF de la ROM
; la ROM page 12 correspond  la zone 30000-33FFF de la ROM
; la ROM page 13 correspond  la zone 34000-37FFF de la ROM
; la ROM page 14 correspond  la zone 38000-3BFFF de la ROM
; la ROM page 15 correspond  la zone 3C000-3FFFF de la ROM
;
; la routine que l'on veut excuter  $0C000 se situe donc
; dans la ROM page 3
;
; or, par dfaut la TI-83 est rgle sur la ROM page 12
;
; DONC PRECISION, IL VA FALLOIR:
; - CHANGER LA ROM PAGE A 3
; - EXECUTER LA ROUTINE $0C000 QUI SERA ALORS MAPPEE A L'ADRESSE $04000


; SOURCE
; ------

; pour rgler une ROM page de 0  7, il faut dj mettre  0 le bit 4 du port (0)
; (si il est  1, ce qui est le cas par dfaut, on ne peut rgler que les ROM pages de 8  15)

 in a,(0)       ; rcupre le port 0
 ld b,%11101111 ;  
 and b          ; met le bit 4  0 sans changer les autres bits
 out (0),a      ; crit la nouvelle valeur du port (0)

; on choisit alors les ROM pages 0  7 ou 8  15
; en crivant dans le port (2) les valeurs $88  $8F

 ld a,$8B       ; on se prpare  rgler la ROM page 3
 out (2),a      ; crit la nouvelle valeur du port (2)
 call $4000     ; lance la routine de l'auto-test maintenant accessible
 RET
.end
